abuild.in 54.4 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# abuild - build apk packages (light version of makepkg)
4
# Copyright (c) 2008-2015 Natanael Copa <ncopa@alpinelinux.org>
Natanael Copa's avatar
Natanael Copa committed
5 6 7 8
#
# Distributed under GPL-2
#

9
program_version=@VERSION@
Natanael Copa's avatar
Natanael Copa committed
10
sysconfdir=@sysconfdir@
11
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
12
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
13

14
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
15

16 17 18 19 20 21
if ! [ -f "$datadir/functions.sh" ]; then
	echo "$datadir/functions.sh: not found" >&2
	exit 1
fi
. "$datadir/functions.sh"

Natanael Copa's avatar
Natanael Copa committed
22
# defaults
23
BUILD_BASE="build-base"
24

25 26 27 28 29
: ${FAKEROOT:="fakeroot"}
: ${SUDO_APK:="abuild-apk"}
: ${APK:="apk"}
: ${ADDUSER:="abuild-adduser"}
: ${ADDGROUP:="abuild-addgroup"}
30

31
apk_opt_wait="--wait 30"
32

33 34 35 36 37
# run optional log command for remote logging
logcmd() {
	${ABUILD_LOG_CMD:-true} "$@"
	return 0
}
Natanael Copa's avatar
Natanael Copa committed
38

39
# we override the default msg, warning and error as we want the pkgname
Natanael Copa's avatar
Natanael Copa committed
40
msg() {
41
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
42 43 44
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
45 46 47
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

Natanael Copa's avatar
Natanael Copa committed
48 49 50 51
warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
52 53 54
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

Natanael Copa's avatar
Natanael Copa committed
55 56 57 58
error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
59
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
60
	logcmd "ERROR: $pkgname: $1"
61 62
}

63 64 65 66
cross_compiling() {
	test "$CBUILD" != "$CHOST" -a -n "$CBUILDROOT"
}

Linux User's avatar
Linux User committed
67
cleanup() {
68
	local i=
Linux User's avatar
Linux User committed
69
	set_xterm_title ""
70 71 72
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
73 74 75 76 77 78 79
	for i; do
		case $i in
		pkgdir) msg "Cleaning up pkgdir"; rm -rf "$pkgbasedir";;
		srcdir) msg "Cleaning up srcdir"; rm -rf "$srcdir";;
		deps)
			if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
				msg "Uninstalling dependencies..."
80
				$SUDO_APK del --quiet $apk_opt_wait $uninstall_after
81
				if cross_compiling; then
82 83 84 85
					$SUDO_APK del --root "$CBUILDROOT" \
						--quiet $apk_opt_wait \
						$uninstall_after
				fi
86 87 88 89
			fi
			;;
		esac
	done
Linux User's avatar
Linux User committed
90 91
}

Natanael Copa's avatar
Natanael Copa committed
92
die() {
Linux User's avatar
Linux User committed
93
	error "$@"
94
	cleanup $ERROR_CLEANUP
Natanael Copa's avatar
Natanael Copa committed
95 96 97
	exit 1
}

98 99 100 101
spell_error() {
	die "APKBUILD contains '$1'. It should be '$2'"
}

102
# check if apkbuild is basicly sane
103
default_sanitycheck() {
104
	local i= j= suggestion=
105
	msg "Checking sanity of $APKBUILD..."
106 107 108
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
109
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
110
		$APK version --check --quiet "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
111 112
			die "$pkgver is not a valid version"
	fi
113
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
114 115 116
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"
Natanael Copa's avatar
Natanael Copa committed
117 118 119
	if [ $(echo "$pkgdesc" | wc -c) -gt 128 ]; then
		die "pkgdesc is too long"
	fi
120
	is_function package || warning "Missing package() function in APKBUILD"
121

Natanael Copa's avatar
Natanael Copa committed
122 123
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
124 125
		die "replaces_priority must be a number"
	fi
126 127 128 129 130 131 132
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

133
	# check if CARCH, CBUILD, CHOST and CTARGET is set
134 135
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

136
	if [ -z "$CARCH" ]; then
Natanael Copa's avatar
Natanael Copa committed
137
		die "Please fix CHOST, or set CARCH in abuild.conf"
138
	fi
139

Natanael Copa's avatar
Natanael Copa committed
140
	for i in $install; do
141
		local n=${i%.*}
142
		local suff=${i##*.}
143 144 145 146 147
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
148
			die "$i: install script does not match pkgname or any subpackage"
149
		fi
150
		[ -e "$startdir/$i" ] || die "install script $i is missing"
151 152 153 154 155 156
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
157
	done
158

159 160 161
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
162
		[ "$f" = "$i" ] && die "$f: triggers must contain '='"
163 164 165 166
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
167

168 169
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
170 171
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
172 173 174 175
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
Natanael Copa's avatar
Natanael Copa committed
176
			case "$i" in
177
				*::*) i=${i%%::*};;
178
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
Natanael Copa's avatar
Natanael Copa committed
179
			esac
180 181
			list_has ${i##*/} $md5sums $sha256sums $sha512sums \
				|| die "${i##*/} is missing in checksums"
182 183 184 185 186 187 188 189 190 191

			# verify that our source does not have git tag version
			# name as tarball (typicallly github)
			if is_remote "$i" && [ "${i#*::}" = "$i" ]; then
				case ${i##*/} in
				v$pkgver.tar.*|$pkgver.tar.*)
					die "source ${i##*/} needs to be renamed to avoid possible collisions"
					;;
				esac
			fi
192 193
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
194

195 196 197 198 199 200 201 202
	# verify that things listed in checksum also is listed in source
	local algo=
	for algo in md5 sha256 sha512; do
		eval set -- \$${algo}sums
		while [ $# -gt 1 ]; do
			local file="$2"
			shift 2
			source_has $file || die "$file exists in ${algo}sums but is missing in source"
203
		done
204
	done
205

206
	# common spelling errors
207 208 209 210 211
	[ -n "$depend" ] && spell_error depend depends
	[ -n "$makedepend" ] && spell_error makedepend makedepends
	[ -n "$pkguser" ] && spell_error pkguser pkgusers
	[ -n "$pkggroup" ] && spell_error pkggroup pkggroups
	[ -n "$subpackage" ] && spell_error subpackage subpackages
Natanael Copa's avatar
Natanael Copa committed
212 213

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
214 215

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
216 217 218
	return 0
}

219 220 221 222
sanitycheck() {
	default_sanitycheck
}

223 224
sumcheck() {
	local algo="$1" sums="$2"
225
	local dummy f endreturnval originalparams origin file
226 227 228 229 230 231 232 233

	# get number of checksums
	set -- $sums
	local numsums=$(( $# / 2 ))

	set -- $source
	if [ $# -ne $numsums ]; then
		die "Number of ${algo}sums($numsums) does not correspond to number of sources($#)"
234
	fi
235
	fetch || return 1
236
	msg "Checking ${algo}sums..."
Natanael Copa's avatar
Natanael Copa committed
237
	cd "$srcdir" || return 1
238 239
	IFS=$'\n'
	endreturnval=0
240
	for src in $sums; do
241
		origin=$1; shift
242
		echo "$src" | ${algo}sum -c
243
		if [ $? -ne 0 ]; then
244
			endreturnval=1
245
			is_remote $origin || continue
246
			echo "Because the remote file above failed the ${algo}sum check it will be deleted."
247 248 249 250 251 252 253 254
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
255 256
}

257 258 259 260 261 262 263 264 265
# for compatibility
md5check() {
	warning "'md5check' is deprecated. Use 'verify' instead"
	sumcheck md5 "$md5sums"
}

# verify checksums
verify() {
	local verified=false algo=
266
	for algo in sha512 sha256 sha1 md5; do
267 268 269 270 271 272 273
		local sums=
		eval sums=\"\$${algo}sums\"
		if [ -z "$sums" ] || [ -z "$source" ]; then
			continue
		fi
		sumcheck "$algo" "$sums" || return 1
		verified=true
274
		break
275 276 277 278 279 280 281
	done
	if [ -n "$source" ] && ! $verified; then
		die "Use 'abuild checksum' to generate/update the checksum(s)"
	fi
	return 0
}

Natanael Copa's avatar
Natanael Copa committed
282 283
# verify upstream sources
sourcecheck() {
284 285 286 287 288 289 290 291
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
292 293 294
		*::*)
			uri=${uri##*::}
			;;
295 296
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
297
	done
298
	return 0
Natanael Copa's avatar
Natanael Copa committed
299
}
300

301 302 303
# convert curl options to wget options and call wget instead of curl
wget_fallback() {
	local wget_opts= outfile= opt=
304
	while getopts "C:Lko:s" opt; do
305
		case $opt in
306
		'L') ;; # --location. wget does this by default
307
		'f') ;; # --fail. wget does this by default
308 309 310 311 312 313 314 315 316 317
		'C') wget_opts="$wget_opts -c";; # --continue-at
		's') wget_opts="$wget_opts -q";; # --silent
		'o') wget_opts="$wget_opts -O $OPTARG";; # --output
		'k') wget_opts="$wget_opts --no-check-certificate";; #gnu wget
		esac
	done
	shift $(( $OPTIND - 1 ))
	wget $wget_opts "$1"
}

Natanael Copa's avatar
Natanael Copa committed
318 319
uri_fetch() {
	local uri="$1"
320
	local d="${uri##*/}"	# $(basename $uri)
321
	local opts
322
	[ -n "$quiet" ] && opts="-s"
323 324

	local lockfile="$SRCDEST/$d".lock
325

326 327 328 329 330
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
331 332 333 334 335

		*::*)
			d=${uri%%::*}
			uri=${uri#$d::}
			;;
Natanael Copa's avatar
Natanael Copa committed
336
	esac
337 338

	case "$uri" in
339
		https://*) opts="-k";;
340
	esac
341

Natanael Copa's avatar
Natanael Copa committed
342
	mkdir -p "$SRCDEST"
343 344 345

	CLEANUP_FILES="$CLEANUP_FILES $lockfile"
	(
346 347
	flock -n -x 9 || msg "Waiting for ${lockfile##*/}..."
	flock -x 9
348 349 350

	[ -f "$SRCDEST/$d" ] && exit 0 # use exit since its a subshell

351 352
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
353
		opts="$opts -C -"
Natanael Copa's avatar
Natanael Copa committed
354
	fi
Linux User's avatar
Linux User committed
355
	msg "Fetching $uri"
356 357

	# fallback to wget if curl is missing. useful for bootstrapping
358
	local fetcher=
359 360
	if ! [ -x "$(which curl)" ]; then
		fetcher=wget_fallback
361 362
	else
		fetcher=curl
363
		opts="$opts -L -f -k"
364 365 366
	fi

	$fetcher $opts -o "$SRCDEST/$d.part" "$uri" \
367
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
368

369
	) 9>$lockfile
370 371 372 373

	local rc=$?
	rm -f "$lockfile"
	return $rc
Natanael Copa's avatar
Natanael Copa committed
374 375
}

376
is_remote() {
377
	case "${1#*::}" in
378
		http://*|ftp://*|https://*|saveas-*://*)
379 380 381 382 383
			return 0;;
	esac
	return 1
}

384 385 386 387 388 389 390 391 392
filename_from_uri() {
	local uri="$1"
	local filename="${uri##*/}"  # $(basename $uri)
	case "$uri" in
	*::*) filename=${uri%%::*};;
	esac
	echo "$filename"
}

393 394 395 396
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	if [ -n "$DISTFILES_MIRROR" ]; then
397
		if is_remote "$DISTFILES_MIRROR"; then
398 399
			uri_fetch "$DISTFILES_MIRROR"/$(filename_from_uri $uri)\
				&& return 0
400
		else
401 402
			cp "$DISTFILES_MIRROR"/$(filename_from_uri $uri) \
				"$SRCDEST" && return 0
403
		fi
404 405 406 407
	fi
	uri_fetch "$uri"
}

408
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
409 410
	local s
	mkdir -p "$srcdir"
411 412
	for s in $source; do
		if is_remote "$s"; then
413
			uri_fetch_mirror "$s" || return 1
414
			ln -sf "$SRCDEST/$(filename_from_uri $s)" "$srcdir"/
415
		else
416 417
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
418 419 420
	done
}

421 422 423 424
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
425 426
# verify that all init.d scripts are openrc runscripts
initdcheck() {
427
	local i line
Natanael Copa's avatar
Natanael Copa committed
428 429
	for i in $source; do
		case $i in
430 431 432 433 434 435 436 437 438 439 440
		*.initd) line=$(head -n 1 "$srcdir"/$i);;
		*) continue ;;
		esac

		case "$line" in
		*sbin/openrc-run)
			;;
		*sbin/runscript)
			warning "$i is not an openrc #!/sbin/openrc-run"
			;;
		*)	error "$i is not an openrc #!/sbin/openrc-run"
Natanael Copa's avatar
Natanael Copa committed
441 442 443
			return 1
			;;
		esac
444
	done
Natanael Copa's avatar
Natanael Copa committed
445 446
}

Natanael Copa's avatar
Natanael Copa committed
447
# unpack the sources
448
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
449
	local u
450
	if [ -z "$force" ]; then
451
		verify || return 1
Natanael Copa's avatar
Natanael Copa committed
452
		initdcheck || return 1
453
	fi
Natanael Copa's avatar
Natanael Copa committed
454 455
	mkdir -p "$srcdir"
	for u in $source; do
456
		local s="$SRCDEST/$(filename_from_uri $u)"
Natanael Copa's avatar
Natanael Copa committed
457
		case "$s" in
458 459 460
			*.tar)
				msg "Unpacking $s..."
				tar -C "$srcdir" -xf "$s" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
461
			*.tar.gz|*.tgz)
462
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
463 464
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
465
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
466
				tar -C "$srcdir" -jxf "$s" || return 1;;
467 468 469 470
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
471 472 473
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
474 475 476
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
477 478 479 480
		esac
	done
}

481 482 483 484
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
485 486
# cleanup source and package dir
clean() {
487
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
488
	rm -rf "$srcdir"
489
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
490 491 492 493 494 495
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
496
		if is_remote "$s"; then
497 498 499
			s=$(filename_from_uri $s)
			msg "Cleaning downloaded $s ..."
			rm -f "$SRCDEST/$s"
500
		fi
Natanael Copa's avatar
Natanael Copa committed
501 502 503
	done
}

504 505 506 507 508 509 510 511 512 513
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
514 515
cleanpkg() {
	local i
516
	getpkgver || return 1
517
	msg "Cleaning built packages..."
518
	for i in $(listpkgnames); do
519 520
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
521
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
522
	done
523
	# remove given packages from index
524
	update_abuildrepo_index
Natanael Copa's avatar
Natanael Copa committed
525 526
}

527 528 529
# clean all packages except current
cleanoldpkg() {
	local i j
530
	getpkgver || return 1
531
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
532
	for i in $(listpkgnames); do
533 534 535 536 537
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
538 539
		done
	done
540
	update_abuildrepo_index
541 542
	return 0
}
543 544 545

mkusers() {
	local i
546 547 548 549 550 551
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
552 553
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
554
			local gopt=
555
			msg "Creating user $i"
556 557 558
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
559
			$ADDUSER -S -D -H $gopt $i || return 1
560 561 562 563
		fi
	done
}

Natanael Copa's avatar
Natanael Copa committed
564 565
# helper to update config.sub to a recent version
update_config_sub() {
566
	local changed=false
Natanael Copa's avatar
Natanael Copa committed
567
	find . -name config.sub | while read f; do
568 569
		if ! ./$f armv6-alpine-linux-muslgnueabihf 2>/dev/null; then
			msg "Updating $f"
570 571 572
			cp "$datadir"/${f##*/} "$f" || return 1
			changed=true
		else
573
			msg "No update needed for $f"
574 575 576
		fi
		# pipe subshell will return status of last command
		$changed
Natanael Copa's avatar
Natanael Copa committed
577
	done
578
	return $?
Natanael Copa's avatar
Natanael Copa committed
579
}
580

Natanael Copa's avatar
Natanael Copa committed
581 582
runpart() {
	local part=$1
583
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
584 585 586 587
	$part || die "$part failed"
}

# override those in your build script
588 589 590 591 592 593 594 595
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
596 597 598 599
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
600
build() {
601
	:
Natanael Copa's avatar
Natanael Copa committed
602 603
}

604 605 606
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
607
	mkdir -p "$PKGDEST"
608 609 610
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
611 612 613 614 615 616 617 618 619
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

620 621 622
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
623
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
624 625 626 627 628 629 630
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
631 632 633 634
		if [ -d "$dir"/usr/var ]; then
			error "Found /usr/var, localstatedir is most likely wrong"
			return 1
		fi
Natanael Copa's avatar
Natanael Copa committed
635
	fi
636 637 638 639

	# remove *.la files if libtool is not set
	if ! options_has "libtool"; then
		find "$dir" -name '*.la' -type f -delete
640
	fi
641

642 643 644 645 646 647
	# look for /usr/lib/charset.alias
	if [ -e "$dir"/usr/lib/charset.alias ] \
			&& ! options_has "charset.alias"; then
		error "Found /usr/lib/charset.alias"
		return 1
	fi
648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665
	# look for /usr/share/doc
	if [ -e "$dir"/usr/share/doc ] \
			&& ! is_doc_pkg; then
		warning "Found /usr/share/doc but package name doesn't end with -doc"
	fi
	# look for /usr/share/man
	if [ -e "$dir"/usr/share/man ] \
			&& ! is_doc_pkg; then
		warning "Found /usr/share/man but package name doesn't end with -doc"

		# check for uncompressed man pages
		i=$(find "$dir"/usr/share/man -name '*.[0-9]' -type f | sed "s|^$dir|\t|")
		if [ -n "$i" ]; then
			error "Found uncompressed man pages:"
			echo "$i"
			return 1
		fi
	fi
666 667 668 669 670 671
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
672
	# check so we dont have any suid root binaries that are not PIE
673 674 675 676 677 678 679 680
	i=$(find "$dir" -type f -perm +6000 \
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
681 682 683 684 685 686 687 688 689 690 691
	# test suid bit on executable
	if ! options_has "suid"; then
		i=$(find "$dir" \( -perm -u+s -o -perm -g+s \) -a -type f \
			-a -perm -o+x)
		if [ -n "$i" ]; then
			error "Found executable files with SUID bit set:"
			echo "$i"
			return 1
		fi
	fi

Natanael Copa's avatar
Natanael Copa committed
692 693 694 695 696 697 698 699 700
	# test for textrels
	if ! options_has "textrels"; then
		local res="$(scanelf --recursive --textrel --quiet "$dir")"
		if [ -n "$res" ]; then
			error "Found textrels:"
			echo "$res"
			return 1
		fi
	fi
701 702 703
	return 0
}

704 705 706 707 708 709 710
pre_split() {
	if [ -z "$subpkgname" ]; then
		return 0
	fi
	# the subpackages should not inherit those form main package
	provides=""
	install_if=""
711
	apkbuild_arch="$arch"
712 713
}

714
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
715 716
	local i
	cd "$startdir"
717
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
718 719
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
720
		msg "Running split function $func..."
721
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
722
		( subpkgdir="$dir" subpkgname="$name" \
723
			$0 pre_split $func prepare_package \
724
			&& postcheck "$dir" "$name" ) || return 1
Natanael Copa's avatar
Natanael Copa committed
725
	done
726
	postcheck "$pkgdir" "$pkgname" || return 1
727 728
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
729
		warning "Found /usr/share/locale"
730
		warning2 "Maybe add \$pkgname-lang to subpackages?"
731
	fi
Natanael Copa's avatar
Natanael Copa committed
732 733
}

734
default_lang() {
735
	pkgdesc="Languages for package $pkgname"
736 737 738 739 740 741 742 743 744 745 746 747 748
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

749
default_lang_subpkg() {
750 751 752 753
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
754
	pkgdesc="$pkgname language pack for $lang"
755 756
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
757 758 759 760 761
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
762
		|| return 1
763 764 765 766 767
	done
}

lang_subpkg() {
	default_lang_subpkg
768 769 770 771 772 773 774 775 776 777 778
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

779 780 781 782 783 784 785 786 787 788 789 790
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

791 792 793 794 795 796
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

797
prepare_metafiles() {
798
	getpkgver || return 1
799 800
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
801
	local dir=${subpkgdir:-$pkgdir}
802
	local pkg="$name-$pkgver-r$pkgrel.apk"
803
	local pkginfo="$controldir"/.PKGINFO
804
	local sub
805

Natanael Copa's avatar
Natanael Copa committed
806 807
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
808
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
809 810
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
811
	local parch="$CARCH"
812 813 814 815 816

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
817

818 819 820 821 822
	# save arch incase subpackages set it different than main pkg
	if [ "${apkbuild_arch:-$arch}" != "$arch" ]; then
		echo "$arch" > "$controldir"/.arch
	fi

823
	echo "# Generated by $(basename $0) $program_version" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
824
	if [ -n "$FAKEROOTKEY" ]; then
825
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
826
	fi
827 828
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
829
pkgname = $name
830
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
831 832 833 834 835
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
836
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
837
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
838
EOF
839 840
	local i deps
	deps="$depends"
Leslie Polzer's avatar
Leslie Polzer committed
841
	if [ "$pkgname" != "busybox" ] && ! depends_has busybox; then
842 843
		for i in $install $triggers; do
			local s=${i%=*}
844
			[ "$name" != "${s%.*}" ] && continue
845
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
846 847 848 849 850
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
851
	fi
852

853 854 855
	# store last_commit in global var so we only call git once
	if [ -z "$last_commit" ]; then
		last_commit="$(git_last_commit)$(git_dirty)"
856
	fi
857
	echo "commit = $last_commit" >> "$pkginfo"
858 859 860 861 862 863

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

864
	if [ -n "$replaces_priority" ]; then
Natanael Copa's avatar
Natanael Copa committed
865
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
866 867
	fi

Natanael Copa's avatar
Natanael Copa committed
868
	echo "license = $license" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
869
	for i in $replaces; do
870
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
871
	done
872
	for i in $deps; do
873
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
874 875
	done
	for i in $provides; do
876
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
877
	done
878 879 880 881 882 883
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
884 885 886
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
887 888

	local metafiles=".PKGINFO"
889 890 891
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
892
		if [ "$n" != "$name" ]; then
893 894
			continue
		fi
895
		script=${f#$name}
896
		msg "Adding $script"
897
		cp "$startdir/$f" "$controldir/$script" || return 1
898
		chmod +x "$controldir/$script"
899 900
		metafiles="$metafiles $script"
	done
901
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
902
}
903

904
prepare_trace_rpaths() {
905
	local dir=${subpkgdir:-$pkgdir}
906
	local etype= soname= file= sover=
907
	[ "$arch" = "noarch" ] && return 0
908
	options_has "!tracedeps" && return 0
909
	# lets tell all the places we should look for .so files - all rpaths
910 911
	scanelf --quiet --recursive --rpath "$dir" \
		| sed -e 's/[[:space:]].*//' -e 's/:/\n/' | sort -u \
912
		>"$controldir"/.rpaths
913
	if grep -q -x '/usr/lib' "$controldir"/.rpaths; then
914
		warning "Redundant /usr/lib in rpath found"
915 916 917 918 919
	fi
	if grep '^/home/' "$controldir"/.rpaths; then
		error "Has /home/... in rpath"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
920 921
}

922 923 924 925 926 927 928 929 930 931 932 933 934
# search for broken symlinks so we later can pull in proper depends
prepare_symlinks() {
	local dir="${subpkgdir:-$pkgdir}"
	options_has "!tracedeps" && return 0
	cd "$dir" || return 1
	find -type l | while read symlink; do
		if ! [ -e "$symlink" ]; then
			echo "$symlink $(readlink $symlink)" \
				>> "$controldir"/.symlinks
		fi
	done
}

935 936 937 938 939 940 941 942 943 944
prepare_pkgconfig_provides() {
	local dir="${subpkgdir:-$pkgdir}"
	options_has "!tracedeps" && return 0
	cd "$dir" || return 1
	for i in usr/lib/pkgconfig/*.pc; do
		if ! [ -e "$i" ]; then
			continue
		fi
		local f=${i##*/}
		local v=$(PKG_CONFIG_PATH="$dir"/usr/lib/pkgconfig pkg-config \
945
			--modversion ${f%.pc})
946 947 948 949
		echo "${f%.pc}=${v:-0}" >> "$controldir"/.provides-pc
	done
}

950 951 952 953 954 955 956 957 958 959 960 961
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

962 963 964 965 966
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

967 968 969 970 971
# returns true if this is the -doc package
is_doc_pkg() {
	test "${subpkgname%-doc}" != "$subpkgname"
}

972 973 974 975 976 977 978
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
979 980 981
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
982 983 984 985
	fi
	return 0
}

986
prepare_package() {
987
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
988
	stripbin
989 990 991 992
	prepare_metafiles \
		&& prepare_trace_rpaths \
		&& prepare_symlinks \
		&& prepare_pkgconfig_provides \
993
		|| return 1
994
	archcheck
995 996 997 998 999 1000 1001 1002
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

1003 1004 1005 1006 1007 1008 1009 1010 1011 1012 1013 1014 1015 1016 1017 1018 1019 1020 1021 1022 1023 1024 1025
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

1026
subpkg_provides_so() {
1027 1028 1029
	grep -q -w "^$1" "$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

1030
subpkg_provides_pc() {
1031 1032
	grep -q -w "^${1%%[<>=]*}" "$pkgbasedir"/.control.*/.provides-pc \
		2>/dev/null
1033 1034
}

1035 1036 1037
trace_apk_deps() {
	local name="$1"
	local dir="$2"
1038
	local i= found= autodeps= deppkgs= missing=
1039
	msg "Tracing dependencies..."
1040 1041 1042
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
1043 1044 1045 1046
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
1047 1048
	if [ "$CLIBC" = "uclibc" ] && [ -f "$dir"/.needs-so ] \
			&& grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
1049 1050
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
1051
		msg "  added libgcc (due to libpthread)"
1052
	fi
1053

1054
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
1055 1056 1057
		# first check if its provided by same apkbuild
		grep -q -w "^$i" "$dir"/.provides-so 2>/dev/null && continue

1058
		if subpkg_provides_so "$i" || cross_compiling \
1059
				|| $APK info --quiet --installed "so:$i"; then
1060
			autodeps="$autodeps so:$i"
1061
		else
1062
			missing="$missing $i"
1063
		fi
1064 1065 1066
	done

	# find all packages that holds the so files
1067
	if [ -f "$dir"/.rpaths ]; then
1068 1069
		local so_files=$(find_so_files "$dir"/.rpaths $missing) \
			|| return 1
1070
		deppkgs=$($APK info --quiet --who-owns $so_files) || return 1
1071 1072
	fi

1073
	for found in $deppkgs; do
1074
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
1075 1076 1077
			warning "You can remove '$found' from depends"
			continue
		fi
1078
		autodeps="$autodeps $found"
1079
	done
1080

1081 1082 1083 1084 1085
	# symlink targets
	for i in $(sort -u "$dir"/.symlinks-needs 2>/dev/null); do
		autodeps="$autodeps $i"
	done

1086 1087 1088 1089
	# pkg-config depends
	for i in $(sort -u "$dir"/.needs-pc 2>/dev/null); do
		if subpkg_provides_pc "$i" || cross_compiling \
				|| $APK info --quiet --installed "pc:$i"; then
1090 1091 1092 1093
			local provider=$(apk search --quiet "pc:$i")
			if list_has "$provider" $depends_dev; then
				warning "$provider should be removed from depends_dev"
			fi
1094
			autodeps="$autodeps pc:$i"
1095 1096 1097 1098 1099 1100 1101
		else
			warning "Could not find any provider for pc:$i"
			local pcfile=/usr/lib/pkgconfig/"${i%%[<>=]*}".pc
			if [ -e "$pcfile" ]; then
				local owner=$($APK info --quiet --who-owns $pcfile)
				warning "${owner:-package providing $pcfile} needs to be rebuilt"
			fi
1102 1103 1104
		fi
	done

1105
	echo "# automatically detected:" >> "$dir"/.PKGINFO
1106
	if [ -f "$dir"/.provides-so ]; then
1107
		sed 's/^\(.*\) \([0-9].*\)/provides = so:\1=\2/' "$dir"/.provides-so \
1108
			>> "$dir"/.PKGINFO
1109
	fi
1110
	if [ -f "$dir"/.provides-pc ]; then
1111
		sed 's/^/provides = pc:/' "$dir"/.provides-pc | sort -u \
1112 1113
			>> "$dir"/.PKGINFO
	fi
1114
	[ -z "$autodeps" ] && return 0
1115
	for i in $autodeps; do
1116 1117
		echo "depend = $i"
	done | sort -u >> "$dir"/.PKGINFO
1118 1119
	# display all depends
	sed -n '/^depend =/s/depend = /\t/p' "$dir"/.PKGINFO >&2
1120 1121
}